/*
 * Created on 20.04.2005
 *
 */
package org.eclipse.contribution.junit;

import java.util.Map;

import org.eclipse.core.resources.IMarker;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IncrementalProjectBuilder;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jdt.core.IJavaModelMarker;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
/**
 * @author Andreas
 *
 */
public class AutoTestBuilder extends IncrementalProjectBuilder{
	/**
	 * 
	 */
	public AutoTestBuilder() {
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.core.resources.IncrementalProjectBuilder#build(int, java.util.Map, org.eclipse.core.runtime.IProgressMonitor)
	 */
	protected IProject[] build(int kind, Map args, IProgressMonitor monitor) throws CoreException {
		if (hasBuildErrors())
			return null;
		IJavaProject javaProject = JavaCore.create(getProject());
		IType[] types = new ClassSearcher().findAllTestCases(javaProject, monitor);
		if (JUnitPlugin.trace)
			printTestTypes(types);
		JUnitPlugin.getPlugin().run(types, javaProject, null);
		return null;
	}
	
	/**
	 * @param types
	 */
	private void printTestTypes(IType[] types) {
		System.out.println("Auto Test: ");
		for (int i=0;i<types.length; i++)
			System.out.println("\t"+types[i].getFullyQualifiedName());
	}

	public boolean hasBuildErrors() throws CoreException{
		IMarker[] markers= getProject().findMarkers(
				IJavaModelMarker.JAVA_MODEL_PROBLEM_MARKER, false, IResource.DEPTH_INFINITE);
		for (int i=0; i< markers.length; i++){
			IMarker marker = markers[i];
			if (marker.getAttribute(IMarker.SEVERITY, 0)== IMarker.SEVERITY_ERROR)
				return true;
		}
		return false;
	}

}
