/*
 * Created on 20.04.2005
 *
 */
package org.eclipse.contribution.junit;

import org.eclipse.core.resources.ICommand;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IProjectNature;
import org.eclipse.core.runtime.CoreException;

/**
 * @author Andreas
 *
 */
public class AutoTestNature implements IProjectNature{

	IProject project;
	
	public AutoTestNature() {
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.core.resources.IProjectNature#configure()
	 */
	public void configure() throws CoreException {
		IProjectDescription description = getProject().getDescription();
		ICommand[] commands = description.getBuildSpec();
		for (int i = 0; i< commands.length; i++)
			if (commands[i].getBuilderName().equals(JUnitPlugin.AUTO_TEST_BUILDER))
				return;
		
		ICommand command = description.newCommand();
		command.setBuilderName(JUnitPlugin.AUTO_TEST_BUILDER);
		ICommand[] newCommands = new ICommand[commands.length+1];
		System.arraycopy(commands, 0, newCommands, 0, commands.length);
		newCommands[newCommands.length-1]=command;
		description.setBuildSpec(newCommands);
		getProject().setDescription(description, null);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.core.resources.IProjectNature#deconfigure()
	 */
	public void deconfigure() throws CoreException {
		IProjectDescription description = getProject().getDescription();
		ICommand[] commands = description.getBuildSpec();
		for (int i = 0; i< commands.length; i++){
			if (commands[i].getBuilderName().equals(JUnitPlugin.AUTO_TEST_BUILDER)){
				//ICommand command = description.newCommand();
				//command.setBuilderName(JUnitPlugin.AUTO_TEST_BUILDER);
				ICommand[] newCommands = new ICommand[commands.length-1];
				System.arraycopy(commands, 0, newCommands, 0, i);
				System.arraycopy(commands, i+1, newCommands, i, commands.length-i-1);
				//System.arraycopy(commands, 0, newCommands, 0, commands.length);
				description.setBuildSpec(newCommands);
				getProject().setDescription(description, null);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.core.resources.IProjectNature#getProject()
	 */
	public IProject getProject() {
		return project;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.core.resources.IProjectNature#setProject(org.eclipse.core.resources.IProject)
	 */
	public void setProject(IProject project) {
		this.project = project;
	}

}
