/*
 * Created on 09.06.2005
 *
 */
package org.eclipse.contribution.junit;

import org.eclipse.debug.core.DebugException;
import org.eclipse.debug.core.model.ISourceLocator;
import org.eclipse.debug.core.model.IStackFrame;
import org.eclipse.debug.core.model.IVariable;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;

/**
 * @author Andreas
 *
 */
public class JUnitSourceLocator implements ISourceLocator{
	private IJavaProject project;

	public JUnitSourceLocator(IJavaProject project){
		this.project = project;
	}
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ISourceLocator#getSourceElement(org.eclipse.debug.core.model.IStackFrame)
	 */
	public Object getSourceElement(IStackFrame stackFrame) {
		if (stackFrame == null)
			return null;
		try {
			ClassSearcher csearcher = new ClassSearcher();
			IType[] types = csearcher.findAllTestCases(project, null);
			IVariable [] vars = stackFrame.getVariables();
			String [] methodargs = new String[30];
			for (int i=0; i<vars.length;i++)
				methodargs[i] = vars[i].getReferenceTypeName();
			for (int i = 0; i<types.length;i++){
				IMethod method = types[i].getMethod(stackFrame.getName(), methodargs);
				if (method!=null)
					return method.getCompilationUnit();
			}
			stackFrame.getName();
		} catch (DebugException e) {
			e.printStackTrace();
		} catch (JavaModelException e) {
			e.printStackTrace();
		}
		return null;
	}

}
