/*
 * Created on 23.09.2005
 *
 */
package org.eclipse.contribution.junit;

import org.eclipse.core.resources.IMarker;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.ui.internal.ide.IMarkerImageProvider;


/**
 * @author Andreas
 *
 */
public class TestImageProvider implements IMarkerImageProvider {

	/* (non-Javadoc)
	 * @see org.eclipse.ui.internal.ide.IMarkerImageProvider#getImagePath(org.eclipse.core.resources.IMarker)
	 */
	public String getImagePath(IMarker marker) {
		String iconPath = "icons/";	
		if (isMarkerType(marker, "org.eclipse.contribution.junit.testMarker")) {
			if (marker.getAttribute("org.eclipse.contribution.junit.type", " ").equals(MarkerCreator.OK_MARKER))
				return iconPath+"ok.gif";
			else if (marker.getAttribute("org.eclipse.contribution.junit.type", " ").equals(MarkerCreator.FAILURE_MARKER))
				return iconPath+"failure.gif";
			else if (marker.getAttribute("org.eclipse.contribution.junit.type", " ").equals(MarkerCreator.UNKNOWN_MARKER))
				return iconPath+"unknown.gif";
			else if (marker.getAttribute("org.eclipse.contribution.junit.type", " ").equals(MarkerCreator.CHANGED_MARKER))
				return iconPath+"changed.gif";
		}
		return null;
	}
	
	private boolean isMarkerType(IMarker marker, String type) {
		try {
			return marker.isSubtypeOf(type);
		} catch (CoreException e) {
			return false;
		}
	}

}
