/*
 * Created on 27.04.2005
 *
 */
package org.eclipse.contribution.junit;

import org.eclipse.core.resources.IMarker;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.search.SearchMatch;
import org.eclipse.jdt.core.search.SearchRequestor;
import org.eclipse.jdt.internal.core.PackageFragment;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.IDE;

/**
 * @author Andreas
 *
 */
public class JUnitSearchRequestor extends SearchRequestor{
   
	String klassname, methodname;

	
	/**
	 * @param klassname
	 * @param methodname
	 */
	public JUnitSearchRequestor(String klassname, String methodname) {
		super();
		this.klassname = klassname;
		this.methodname = methodname;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jdt.core.search.SearchRequestor#acceptSearchMatch(org.eclipse.jdt.core.search.SearchMatch)
	 */
	public void acceptSearchMatch(SearchMatch match) throws CoreException {
		String actualklass;
		String packagename;
	    IMarker searchmarker;
	    IResource searchresult;
	    IJavaElement e;
	    
		searchresult = match.getResource();
		
		e = JavaCore.create(searchresult);
		if (e == null)
			return;
		actualklass = e.getElementName();
		e = e.getParent();
		if (!(e instanceof PackageFragment))
			return;
		packagename = e.getElementName();
		if (!packagename.equals(""))//there is another package than the default one			
			actualklass = e.getElementName()+"."+actualklass;
				
		if (!actualklass.equals(klassname+".java"))
			return;
		
		searchmarker = searchresult.createMarker(JUnitPlugin.SEARCH_MARKER);
		searchmarker.setAttribute(IMarker.CHAR_START, new Integer(match.getOffset()));
		searchmarker.setAttribute(IMarker.CHAR_END, new Integer(match.getOffset()));
		IDE.openEditor(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage(), searchmarker, true);
		searchmarker.delete();
		
	    if(JUnitPlugin.trace)
			System.out.println("MATCH: "+match.toString());
	}

}
