/*
 * Created on 15.03.2005
 *
 */
package org.eclipse.contribution.junit;



import org.eclipse.core.runtime.*;
import org.eclipse.jdt.core.*;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;


/**
 * @author Andreas
 *
 */
public class RunTestAction implements IObjectActionDelegate{

	ISelection selection;

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IObjectActionDelegate#setActivePart(org.eclipse.jface.action.IAction, org.eclipse.ui.IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 */
	public void run(IAction action) {
		if (! (selection instanceof IStructuredSelection))
			return;
		IStructuredSelection structured = (IStructuredSelection) selection;
		IType type = (IType) structured.getFirstElement();
		try {
			IType[] types = new ClassSearcher().findAllTestCases(type.getJavaProject(),
					null);
			
			ITestRunListener listener = new Listener();
			JUnitPlugin.getPlugin().addTestListener(listener);
			JUnitPlugin.getPlugin().run(types, (IJavaProject) type.getJavaProject(), action);
			JUnitPlugin.getPlugin().removeTestListener(listener);			
		} catch (JavaModelException e) {
			e.printStackTrace();
		} catch (CoreException e) {
			e.printStackTrace();
		}
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;
	}
	
	public static class Listener implements ITestRunListener{

		private boolean passed = true;
		
		public void testsStarted(int testCount, IJavaProject project) {
		}

		public void testsFinished(IJavaProject project) {
			String message = passed ? "Pass" : "Fail";
			if (JUnitPlugin.trace)
				System.out.println("Test Results: "+message);
		}

		
		public void testStarted(String klass, String method, IJavaProject project) {			
		}

		
		public void testFailed(String klass, String method, String trace, IJavaProject project) {
			passed = false;
		}

		/* (non-Javadoc)
		 * @see org.eclipse.contribution.junit.ITestRunListener#testEnded(java.lang.String, java.lang.String, org.eclipse.jdt.core.IJavaProject)
		 */
		public void testOk(String klass, String method, IJavaProject project) {			
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.core.runtime.jobs.Job#run(org.eclipse.core.runtime.IProgressMonitor)
	 */
}
